/**
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 -
 - JASS: Java Advanced tranSaction Support
 -
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 -
 - This module was originally developed by 
 -
 -    LSD (Distributed Systems Lab, http://lsd.ls.fi.upm.es/lsd/lsd.htm)
 -    at Universidad Politecnica de Madrid (UPM) as an ObjectWeb Consortium
 -    (http://www.objectweb.org) project.
 -
 -    This project has been partially funded by the European Commission under
 -    the IST programme of V FP grant IST-2001-37126 and by the Spanish
 -    Ministry of Science & Technology (MCyT) grants TIC2002-10376-E and
 -    TIC2001-1586-C03-02
 -
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 -  The original code and portions created by LSD are 
 -  Copyright (c) 2004 LSD (UPM)  
 -  All rights reserved.
 -  
 - Redistribution and use in source and binary forms, with or without 
 - modification, are permitted provided that the following conditions are met:
 -
 - -Redistributions of source code must retain the above copyright notice, this
 - list of conditions and the following disclaimer. 
 -
 - -Redistributions in binary form must reproduce the above copyright notice, 
 - this list of conditions and the following disclaimer in the documentation 
 - and/or other materials provided with the distribution. 
 -
 - THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 - AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 - IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 - ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 - LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 - CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 - SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 - INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 - CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 - ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 - POSSIBILITY OF SUCH DAMAGE.
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 -
 -  Author: Francisco Perez-Sorrosal (fpsorrosal@fi.upm.es)
 -
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*/

package org.omg.CosActivity;

import javax.activity.ActivityCoordinator;
import javax.activity.CompletionStatus;
import javax.activity.CoordinationInformation;
import javax.activity.Outcome;
import javax.activity.Signal;
import javax.activity.SignalSetActiveException;
import javax.activity.SignalSetInactiveException;
import javax.activity.coordination.SignalSet;

public class Failure implements SignalSet {
    // SignalSet name
    public static final String SSNAME = "org.omg.CosActivity.Failure";

    // The name of this SignalSet
    private String signalSetName;

    private ActivityCoordinator ac;

    private int completionStatus;

    private int status;

    private Outcome outcome;

    private boolean started;
    private boolean finished;

    public Failure() {
        signalSetName = SSNAME;
        this.outcome = null;
        this.started = false;
        this.finished = false;
    }
    public String getSignalSetName() {
        return SSNAME;
    }


    // FALTA IMPLEMENTAR
    public Signal getSignal() {
        return null;
    }

    public CoordinationInformation setResponse(Outcome response)
            throws SignalSetInactiveException {
        if (! started) throw new SignalSetInactiveException();

        CoordinationInformation info = new CoordinationInformation(false, false);

        if ((completionStatus != CompletionStatus.CompletionStatusFailOnly) && (response.getName().equals("ActionError") || response.getName().equals("ActionError"))) {
                completionStatus = CompletionStatus.CompletionStatusFailOnly;
        }

        return info;
    }

    public Outcome getOutcome()
            throws SignalSetActiveException {
        return outcome;
    }

    public void setCompletionStatus(int completionStatus,
                                    int status) {
        this.completionStatus = completionStatus;
        this.status = status;
    }

    public int getCompletionStatus()
            throws SignalSetActiveException {
        if (! finished) throw new SignalSetActiveException();
        return this.completionStatus;
    }

    public void setActivityCoordinator(ActivityCoordinator coord)
            throws SignalSetActiveException {
        if (started) throw new SignalSetActiveException();
        ac = coord;
    }

    public void destroy() {
        ac = null;
    }
}
